## DraggableElement 可拖拽元素 (v0.0.8新增)

可拖拽元素是一个脱离文档流的元素，它允许你拖拽至任意位置，并可以正确触发onClick事件

#### 基本使用

```javascript
import {
  DraggableElement,
} from 'ui-hub';

// ...
<DraggableElement
  position="fixed"
  initBottom="10%"
  initRight="10%"
  onClick={() => {
    console.log('trigger onClick');
  }}
>
  <img
    src="https://jj-img2019.oss-cn-hangzhou.aliyuncs.com/adv/adv_20200907172241_product_1b267ecd.gif"
  />
</DraggableElement>
```

#### API

| 成员 | 说明 | 类型 | 默认值 | 版本 |
| --- | --- | --- | --- | --- |
| prefixCls | class 前缀 | string | - | 0.0.8 |
| className | class | string | - | 0.0.8 |
| style | 附加至可拖拽容器盒的样式 | React.CSSProperties | - | 0.0.8 |
| position | 定位方式 | 'fixed' &#124; 'absolute' | 'absolute' | 0.0.8 |
| initTop | 脱离文档流初始状态下css的top值 | string | - | 0.0.8 |
| initRight | 脱离文档流初始状态下css的right值 | string | - | 0.0.8 |
| initBottom | 脱离文档流初始状态下css的bottom值 | string | - | 0.0.8 |
| initLeft | 脱离文档流初始状态下css的left值 | string | - | 0.0.8 |
| isInView | 是否一直处于视图内（不允许拖拽至视图外） | boolean | true | 0.0.8 |
| onClick | 点击事件回调 | () => void | - | 0.0.8 |