import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import cn from 'classnames';
import { isDef } from '../_util';
import { defaultPrefixCls } from '../_config/dict';
;
;
var eventConfig = {
  passive: false
};
export function getPosition(beginPos, endPos) {
  if (beginPos) {
    return beginPos;
  }

  if (endPos) {
    return "calc(100% - ".concat(endPos, ")");
  }

  return '0px';
}

var DraggableElement = /*#__PURE__*/function (_React$Component) {
  _inherits(DraggableElement, _React$Component);

  var _super = _createSuper(DraggableElement);

  function DraggableElement(props) {
    var _this;

    _classCallCheck(this, DraggableElement);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "shouldTriggerOnClick", true);

    _defineProperty(_assertThisInitialized(_this), "ref", undefined);

    _defineProperty(_assertThisInitialized(_this), "containerRef", undefined);

    _defineProperty(_assertThisInitialized(_this), "initPageX", undefined);

    _defineProperty(_assertThisInitialized(_this), "initPageY", undefined);

    _defineProperty(_assertThisInitialized(_this), "transformX", undefined);

    _defineProperty(_assertThisInitialized(_this), "transformY", undefined);

    _defineProperty(_assertThisInitialized(_this), "resetInnerState", function () {
      _this.shouldTriggerOnClick = true;
      _this.initPageX = undefined;
      _this.initPageY = undefined;
      _this.transformX = undefined;
      _this.transformY = undefined;
    });

    _defineProperty(_assertThisInitialized(_this), "handleTouchStart", function (evt) {
      evt.preventDefault();

      _this.resetInnerState();

      if (!evt.touches) return;
      var touches = evt.touches;

      if (touches.length > 1) {
        return;
      }

      _this.initPageX = touches[0].pageX;
      _this.initPageY = touches[0].pageY;
    });

    _defineProperty(_assertThisInitialized(_this), "handleTouchMove", function (evt) {
      evt.preventDefault();
      _this.shouldTriggerOnClick = false;

      if (!isDef(_this.initPageX) || !isDef(_this.initPageY)) {
        return;
      }

      if (!evt.touches) return;
      var touches = evt.touches;

      if (touches.length > 1) {
        return;
      }

      var _this$props$isInView = _this.props.isInView,
          isInView = _this$props$isInView === void 0 ? true : _this$props$isInView;
      var _touches$ = touches[0],
          pageX = _touches$.pageX,
          pageY = _touches$.pageY;
      var minTransformX = -Infinity;
      var minTransformY = -Infinity;
      var maxTransformX = Infinity;
      var maxTransformY = Infinity;

      if (isInView && _this.ref && _this.ref.current && _this.containerRef && _this.containerRef.current) {
        var _this$ref$current$get = _this.ref.current.getBoundingClientRect(),
            innerW = _this$ref$current$get.width,
            innerH = _this$ref$current$get.height;

        var _this$containerRef$cu = _this.containerRef.current.getBoundingClientRect(),
            width = _this$containerRef$cu.width,
            height = _this$containerRef$cu.height;

        var _this$ref$current = _this.ref.current,
            innerOT = _this$ref$current.offsetTop,
            innerOL = _this$ref$current.offsetLeft;
        maxTransformX = width - innerOL - innerW;
        maxTransformY = height - innerOT - innerH;
        minTransformX = -innerOL;
        minTransformY = -innerOT;
      }

      var x = pageX - _this.initPageX;
      var y = pageY - _this.initPageY;

      if (x > maxTransformX) {
        x = maxTransformX;
      }

      if (x < minTransformX) {
        x = minTransformX;
      }

      if (y > maxTransformY) {
        y = maxTransformY;
      }

      if (y < minTransformY) {
        y = minTransformY;
      }

      _this.transformX = x;
      _this.transformY = y;

      if (_this.ref && _this.ref.current) {
        _this.ref.current.style.transform = "translate(".concat(x, "px, ").concat(y, "px)");
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleTouchEnd", function (evt) {
      evt.preventDefault();

      if (!isDef(_this.initPageX) || !isDef(_this.initPageY)) {
        return;
      }

      if (!evt.touches) return;
      var touches = evt.touches;

      if (touches.length > 1) {
        return;
      }

      var onClick = _this.props.onClick;

      if (_this.shouldTriggerOnClick) {
        typeof onClick === 'function' && onClick();
      }

      _this.handleAdjustElement();
    });

    _defineProperty(_assertThisInitialized(_this), "handleTouchCancel", function (evt) {
      evt.preventDefault();

      _this.handleAdjustElement();
    });

    _defineProperty(_assertThisInitialized(_this), "handleAdjustElement", function () {
      if (_this.ref && _this.ref.current) {
        // 先通过手动修改节点的方式修改样式，然后同步state
        var element = _this.ref.current;
        var offsetTop = "".concat(element.offsetTop + (_this.transformY || 0), "px");
        var offsetLeft = "".concat(element.offsetLeft + (_this.transformX || 0), "px");
        element.style.top = offsetTop;
        element.style.left = offsetLeft;
        element.style.right = 'unset';
        element.style.bottom = 'unset';
        element.style.transform = 'unset';

        _this.setState({
          top: offsetTop,
          left: offsetLeft,
          right: undefined,
          bottom: undefined
        });
      }
    });

    _this.state = {
      top: props.initTop,
      left: props.initLeft,
      right: props.initRight,
      bottom: props.initBottom
    };
    _this.containerRef = /*#__PURE__*/React.createRef();
    _this.ref = /*#__PURE__*/React.createRef();
    return _this;
  }

  _createClass(DraggableElement, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$ref, _this$ref$current2, _this$ref2, _this$ref2$current, _this$ref3, _this$ref3$current, _this$ref4, _this$ref4$current;

      (_this$ref = this.ref) === null || _this$ref === void 0 ? void 0 : (_this$ref$current2 = _this$ref.current) === null || _this$ref$current2 === void 0 ? void 0 : _this$ref$current2.addEventListener('touchstart', this.handleTouchStart, eventConfig);
      (_this$ref2 = this.ref) === null || _this$ref2 === void 0 ? void 0 : (_this$ref2$current = _this$ref2.current) === null || _this$ref2$current === void 0 ? void 0 : _this$ref2$current.addEventListener('touchmove', this.handleTouchMove, eventConfig);
      (_this$ref3 = this.ref) === null || _this$ref3 === void 0 ? void 0 : (_this$ref3$current = _this$ref3.current) === null || _this$ref3$current === void 0 ? void 0 : _this$ref3$current.addEventListener('touchend', this.handleTouchEnd, eventConfig);
      (_this$ref4 = this.ref) === null || _this$ref4 === void 0 ? void 0 : (_this$ref4$current = _this$ref4.current) === null || _this$ref4$current === void 0 ? void 0 : _this$ref4$current.addEventListener('touchcancel', this.handleTouchCancel, eventConfig);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this$ref5, _this$ref5$current, _this$ref6, _this$ref6$current, _this$ref7, _this$ref7$current, _this$ref8, _this$ref8$current;

      (_this$ref5 = this.ref) === null || _this$ref5 === void 0 ? void 0 : (_this$ref5$current = _this$ref5.current) === null || _this$ref5$current === void 0 ? void 0 : _this$ref5$current.removeEventListener('touchstart', this.handleTouchStart);
      (_this$ref6 = this.ref) === null || _this$ref6 === void 0 ? void 0 : (_this$ref6$current = _this$ref6.current) === null || _this$ref6$current === void 0 ? void 0 : _this$ref6$current.removeEventListener('touchmove', this.handleTouchMove);
      (_this$ref7 = this.ref) === null || _this$ref7 === void 0 ? void 0 : (_this$ref7$current = _this$ref7.current) === null || _this$ref7$current === void 0 ? void 0 : _this$ref7$current.removeEventListener('touchend', this.handleTouchEnd);
      (_this$ref8 = this.ref) === null || _this$ref8 === void 0 ? void 0 : (_this$ref8$current = _this$ref8.current) === null || _this$ref8$current === void 0 ? void 0 : _this$ref8$current.removeEventListener('touchcancel', this.handleTouchCancel);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          _this$props$prefixCls = _this$props.prefixCls,
          prefixCls = _this$props$prefixCls === void 0 ? defaultPrefixCls : _this$props$prefixCls,
          _this$props$position = _this$props.position,
          position = _this$props$position === void 0 ? 'absolute' : _this$props$position,
          children = _this$props.children,
          initTop = _this$props.initTop,
          initLeft = _this$props.initLeft,
          initRight = _this$props.initRight,
          initBottom = _this$props.initBottom,
          isInView = _this$props.isInView,
          onClick = _this$props.onClick,
          restProps = _objectWithoutProperties(_this$props, ["className", "style", "prefixCls", "position", "children", "initTop", "initLeft", "initRight", "initBottom", "isInView", "onClick"]);

      var _this$state = this.state,
          top = _this$state.top,
          left = _this$state.left,
          right = _this$state.right,
          bottom = _this$state.bottom;
      return /*#__PURE__*/React.createElement("div", {
        className: cn("".concat(prefixCls, "-draggable-container"), className),
        ref: this.containerRef,
        style: _objectSpread(_objectSpread({}, style || {}), {}, {
          width: '100%',
          height: '100%',
          position: position,
          pointerEvents: 'none'
        })
      }, /*#__PURE__*/React.createElement("div", _extends({}, restProps, {
        ref: this.ref,
        className: "".concat(prefixCls, "-draggable-element"),
        style: {
          top: top,
          left: left,
          right: right,
          bottom: bottom,
          position: position,
          pointerEvents: 'all'
        }
      }), children));
    }
  }]);

  return DraggableElement;
}(React.Component);

export { DraggableElement as default };