import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React, { useRef } from 'react';
import cn from 'classnames';
import FadeIn from '../fade/fadeIn';
import SlideIn from '../slide/slideIn';
import { defaultPrefixCls } from '../_config/dict';
;
;
;

function Drawer(props) {
  var _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? defaultPrefixCls : _props$prefixCls,
      className = props.className,
      _props$maskClosable = props.maskClosable,
      maskClosable = _props$maskClosable === void 0 ? true : _props$maskClosable,
      _props$visible = props.visible,
      visible = _props$visible === void 0 ? true : _props$visible,
      children = props.children,
      _props$direction = props.direction,
      direction = _props$direction === void 0 ? 'up' : _props$direction,
      onCancel = props.onCancel,
      onHide = props.onHide,
      onShow = props.onShow,
      _props$mask = props.mask,
      mask = _props$mask === void 0 ? true : _props$mask,
      restProps = _objectWithoutProperties(props, ["prefixCls", "className", "maskClosable", "visible", "children", "direction", "onCancel", "onHide", "onShow", "mask"]);

  var maskShowRef = useRef(false);
  var contentEnterRef = useRef(false);

  var handleStatusChange = function handleStatusChange() {
    if ((!mask || maskShowRef.current) && contentEnterRef.current) {
      typeof onShow === 'function' && onShow();
    }

    if ((!mask || !maskShowRef.current) && !contentEnterRef.current) {
      typeof onHide === 'function' && onHide();
    }
  };

  var standardDirection = 'up';

  if (direction === '↓') {
    standardDirection = 'down';
  }

  var onTriggerClose = function onTriggerClose() {
    typeof onCancel === 'function' && onCancel.apply(void 0, arguments);
  };

  return /*#__PURE__*/React.createElement("div", {
    className: cn("".concat(prefixCls, "-drawer"), className)
  }, !!mask && /*#__PURE__*/React.createElement(FadeIn, {
    show: visible,
    onShow: function onShow() {
      maskShowRef.current = true;
      handleStatusChange();
    },
    onHide: function onHide() {
      maskShowRef.current = false;
      handleStatusChange();
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-drawer-mask"),
    onClick: maskClosable ? function () {
      onTriggerClose();
    } : undefined
  })), /*#__PURE__*/React.createElement(SlideIn, {
    direction: direction,
    show: visible,
    onShow: function onShow() {
      contentEnterRef.current = true;
      handleStatusChange();
    },
    onHide: function onHide() {
      contentEnterRef.current = false;
      handleStatusChange();
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: cn("".concat(prefixCls, "-drawer-content"), "".concat(prefixCls, "-drawer-d-").concat(standardDirection))
  }, /*#__PURE__*/React.createElement("div", _extends({
    className: "".concat(prefixCls, "-drawer-box")
  }, restProps), typeof children === 'function' ? children(onTriggerClose) : children))));
}

export default Drawer;