import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React, { useState, useRef, forwardRef, useImperativeHandle } from 'react';
import copy from 'copy-to-clipboard';
import cn from 'classnames';
import useRefState from '../_hook/useRefState/index';
import BaseInput from '../input/input';
import { defaultPrefixCls } from '../_config/dict';
;
;

function GridPwd(props, ref) {
  var _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? defaultPrefixCls : _props$prefixCls,
      _props$gridCount = props.gridCount,
      gridCount = _props$gridCount === void 0 ? 6 : _props$gridCount,
      _props$type = props.type,
      type = _props$type === void 0 ? "tel" : _props$type,
      className = props.className,
      onFinished = props.onFinished,
      onChange = props.onChange,
      restProps = _objectWithoutProperties(props, ["prefixCls", "gridCount", "type", "className", "onFinished", "onChange"]);

  var _useRefState = useRefState(false),
      _useRefState2 = _slicedToArray(_useRefState, 2),
      lockRef = _useRefState2[0],
      setIsLock = _useRefState2[1];

  var _useState = useState(''),
      _useState2 = _slicedToArray(_useState, 2),
      pwd = _useState2[0],
      setPwd = _useState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      isFocus = _useState4[0],
      setIsFocus = _useState4[1];

  var inputRef = useRef();

  var doFocusInput = function doFocusInput() {
    copy('');
    inputRef.current.focus();
  };

  var doBlurInput = function doBlurInput() {
    inputRef.current.blur();
  };

  var reset = function reset() {
    setPwd('');
  };

  var resetAndFocus = function resetAndFocus() {
    reset();
    doFocusInput();
  };

  var onChangePwd = function onChangePwd(v) {
    if (lockRef.current) {
      return;
    }

    setPwd(v);
    typeof onChange === 'function' && onChange(v);

    if (v.length === gridCount) {
      if (typeof onFinished === 'function') {
        var lockCb = function lockCb() {
          setIsLock(false);
        };

        doBlurInput();
        setIsLock(true);
        onFinished(v, lockCb);
      }
    }
  };

  useImperativeHandle(ref, function () {
    return {
      reset: reset,
      resetAndFocus: resetAndFocus
    };
  });

  var renderGridItem = function renderGridItem() {
    var grids = [];
    var pwdLen = pwd.length;

    for (var i = 0; i < gridCount; i++) {
      var _cn;

      grids.push( /*#__PURE__*/React.createElement("div", {
        key: i,
        className: cn("".concat(prefixCls, "-grid-pwd-item"), (_cn = {}, _defineProperty(_cn, "".concat(prefixCls, "-grid-pwd-has-value"), i < pwdLen), _defineProperty(_cn, "".concat(prefixCls, "-grid-pwd-next-grid"), i === pwdLen), _cn))
      }));
    }

    return grids;
  };

  return /*#__PURE__*/React.createElement("div", _extends({
    className: cn("".concat(prefixCls, "-grid-pwd"), className, _defineProperty({}, "".concat(prefixCls, "-grid-pwd-focus"), isFocus))
  }, restProps, {
    onClick: doFocusInput
  }), renderGridItem(), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-grid-pwd-input")
  }, /*#__PURE__*/React.createElement(BaseInput, {
    type: type,
    value: pwd,
    ref: inputRef,
    maxLength: gridCount,
    onChange: onChangePwd,
    disabled: lockRef.current,
    onFocus: function onFocus() {
      setIsFocus(true);
    },
    onBlur: function onBlur() {
      setIsFocus(false);
    },
    autoFocus: !lockRef.current,
    onPaste: function onPaste(e) {
      e.stopPropagation();
      e.preventDefault();
      return false;
    }
  })));
}

;
export default /*#__PURE__*/forwardRef(GridPwd);