import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React, { useState } from 'react';
import cn from 'classnames';
import useRefState from '../_hook/useRefState';
import Drawer from '../drawer/index';
import PickerView from '../picker-view/index';
import { defaultPrefixCls } from '../_config/dict';
import '../drawer/style/css';
import '../picker-view/style/css';
;
export default (function (props) {
  var _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? defaultPrefixCls : _props$prefixCls,
      _props$cancelText = props.cancelText,
      cancelText = _props$cancelText === void 0 ? '取消' : _props$cancelText,
      _props$okText = props.okText,
      okText = _props$okText === void 0 ? '确定' : _props$okText,
      title = props.title,
      _props$defaultValue = props.defaultValue,
      defaultValue = _props$defaultValue === void 0 ? [] : _props$defaultValue,
      onOk = props.onOk,
      onCreatePop = props.onCreatePop,
      popClassName = props.popClassName,
      onCancelCb = props.onCancel,
      maskClosable = props.maskClosable,
      children = props.children,
      restProps = _objectWithoutProperties(props, ["prefixCls", "cancelText", "okText", "title", "defaultValue", "onOk", "onCreatePop", "popClassName", "onCancel", "maskClosable", "children"]); // PickerView提交的实际值


  var _useState = useState(defaultValue),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1]; // PickerView的实时值


  var _useRefState = useRefState(defaultValue),
      _useRefState2 = _slicedToArray(_useRefState, 2),
      currentValueRef = _useRefState2[0],
      setCurrentValue = _useRefState2[1];

  var createPop = function createPop() {
    typeof onCreatePop === 'function' && onCreatePop();
    Drawer.createDrawer({
      maskClosable: maskClosable,
      className: cn("".concat(prefixCls, "-picker-wrapper"), popClassName),
      content: function content(onCancel) {
        return /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-picker")
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-picker-control")
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-picker-cancel"),
          onClick: function onClick() {
            onCancel();
          }
        }, cancelText), /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-picker-title")
        }, title), /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-picker-ok"),
          onClick: function onClick() {
            onCancel(true);
          }
        }, okText)), /*#__PURE__*/React.createElement(PickerView, _extends({}, restProps, {
          defaultValue: currentValueRef.current,
          onChange: function onChange(v) {
            setCurrentValue(v);
          }
        })));
      },
      onCancel: function onCancel(close, isConfirm) {
        if (isConfirm) {
          var v = _toConsumableArray(currentValueRef.current);

          setValue(v);
          typeof onOk === 'function' && onOk(v);
        } else {
          var _v = _toConsumableArray(value);

          setCurrentValue(_v);
          typeof onCancelCb === 'function' && onCancelCb(_v);
        }

        close();
      }
    });
  };

  if (typeof children === 'function') {
    return children(createPop, value, currentValueRef.current);
  } else if (children) {
    // 当接受到数组类型的子节点或者纯文本的节点时, 用一层div包裹, 并在包裹的div上
    if (typeof children === 'string' || Array.isArray(children)) {
      return /*#__PURE__*/React.createElement("div", {
        onClick: function onClick() {
          createPop();
        },
        className: "".concat(prefixCls, "-picker-trigger")
      }, children);
    }

    return /*#__PURE__*/React.cloneElement(children, {
      onClick: function onClick(e) {
        createPop();
        var originOnClick = children.props.onClick;
        typeof originOnClick === 'function' && originOnClick(e);
      }
    });
  }

  return null;
});