import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React, { forwardRef, useEffect, useImperativeHandle, useState } from 'react';
import cn from 'classnames';
import LoadingOutlined from '@ant-design/icons/LoadingOutlined';
import CountDown from '../count-down';
import { defaultPrefixCls } from '../_config/dict';
import useRefState from '../_hook/useRefState';
;
;
export default /*#__PURE__*/forwardRef(function (props, ref) {
  var className = props.className,
      _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? defaultPrefixCls : _props$prefixCls,
      disabled = props.disabled,
      initDispatch = props.initDispatch,
      onClick = props.onClick,
      _props$duration = props.duration,
      duration = _props$duration === void 0 ? 60 : _props$duration,
      onClickDisabled = props.onClickDisabled,
      _props$text = props.text,
      text = _props$text === void 0 ? '获取验证码' : _props$text,
      _props$reText = props.reText,
      reText = _props$reText === void 0 ? '获取验证码' : _props$reText,
      renderCountDown = props.renderCountDown,
      restProps = _objectWithoutProperties(props, ["className", "prefixCls", "disabled", "initDispatch", "onClick", "duration", "onClickDisabled", "text", "reText", "renderCountDown"]);

  var needinitDispatch = !disabled && initDispatch;

  var _useState = useState(true),
      _useState2 = _slicedToArray(_useState, 2),
      isFirst = _useState2[0],
      setIsFirst = _useState2[1];

  var _useRefState = useRefState(needinitDispatch && typeof onClick === 'function' ? true : false),
      _useRefState2 = _slicedToArray(_useRefState, 2),
      isLoadingRef = _useRefState2[0],
      setIsLoading = _useRefState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      isWaitting = _useState4[0],
      setIsWaitting = _useState4[1];

  var beginCountDownFn = function beginCountDownFn() {
    setIsWaitting(true);
    setIsLoading(false);
    setIsFirst(false);
  };

  var cancelCountDown = function cancelCountDown() {
    setIsWaitting(false);
  };

  var cancelLoading = function cancelLoading() {
    setIsLoading(false);
  };

  var triggerOnClick = function triggerOnClick() {
    if (typeof onClick === 'function') {
      setIsLoading(true);

      var _flowControlFn = function _flowControlFn() {
        var isContinue = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

        if (isContinue) {
          beginCountDownFn();
        } else {
          cancelLoading();
        }
      };

      onClick(_flowControlFn);
    } else {
      beginCountDownFn();
    }
  };

  useEffect(function () {
    if (needinitDispatch) {
      triggerOnClick();
    }
  }, []);
  useImperativeHandle(ref, function () {
    return {
      cancelCountDown: cancelCountDown
    };
  });

  var onHandleCountDownFinished = function onHandleCountDownFinished() {
    cancelCountDown();
  };

  var onClickItem = function onClickItem() {
    if (isLoadingRef.current || isWaitting) {
      return;
    }

    if (disabled) {
      typeof onClickDisabled === 'function' && onClickDisabled();
      return;
    }

    triggerOnClick();
  };

  var renderContent = function renderContent() {
    if (isLoadingRef.current) {
      return /*#__PURE__*/React.createElement(LoadingOutlined, null);
    }

    if (isWaitting) {
      return /*#__PURE__*/React.createElement(CountDown, {
        duration: duration,
        formatString: "s",
        onFinished: onHandleCountDownFinished
      }, function (timeStr) {
        if (typeof renderCountDown === 'function') {
          return renderCountDown(timeStr);
        }

        return "".concat(timeStr, "s");
      });
    }

    return isFirst ? text : reText;
  };

  return /*#__PURE__*/React.createElement("div", _extends({}, restProps, {
    className: cn("".concat(prefixCls, "-sms-code-btn"), className, _defineProperty({}, "".concat(prefixCls, "-sms-code-btn-disabled"), disabled || isWaitting)),
    onClick: onClickItem
  }), renderContent());
});