"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _swiper = _interopRequireWildcard(require("swiper"));

var _react2 = require("swiper/react");

var _index = require("../_util/index");

var _dict = require("../_config/dict");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

_swiper["default"].use([_swiper.Virtual, _swiper.Autoplay, _swiper.Pagination]);

;

var _default = function _default(props) {
  var children = props.children,
      className = props.className,
      autoplay = props.autoplay,
      _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? _dict.defaultPrefixCls : _props$prefixCls,
      dots = props.dots,
      restProps = (0, _objectWithoutProperties2["default"])(props, ["children", "className", "autoplay", "prefixCls", "dots"]);
  var autoplayConfig = autoplay;

  var packedChildren = _react["default"].Children.map(children, function (child, i) {
    var key = child.key,
        type = child.type; // 如果元素有定义key值(一般使用时遍历场景更多),则使用这个key值,否则使用index

    var realKey = (0, _index.isDef)(key) ? key : i; // 如果元素已经使用了SwiperSlide组件,整个复制并覆盖key值

    if (type === _react2.SwiperSlide) {
      return /*#__PURE__*/_react["default"].cloneElement(child, {
        key: realKey
      });
    } // 其他的使用SwiperSlide包裹一下


    return /*#__PURE__*/_react["default"].createElement(_react2.SwiperSlide, {
      key: realKey
    }, child);
  });

  if (typeof autoplay === 'boolean' && autoplay) {
    autoplayConfig = {
      disableOnInteraction: false
    };
  } else if (autoplay && (0, _typeof2["default"])(autoplay) === 'object') {
    autoplayConfig = _objectSpread({
      disableOnInteraction: false
    }, autoplay);
  }

  return /*#__PURE__*/_react["default"].createElement(_react2.Swiper, (0, _extends2["default"])({
    className: (0, _classnames["default"])("".concat(prefixCls, "-carousel"), className),
    autoHeight: true,
    pagination: !!dots,
    autoplay: autoplayConfig
  }, restProps), packedChildren);
};

exports["default"] = _default;