## CountDown 倒计时组件

**0.0.4版本新增**

适用于需要显示倒计时的场景。

#### 基本使用

```javascript
<CountDown
  duration={60}
  formatString="ss秒"
  onFinished={() => {
    console.log('finished');
  }}
>
  {
    (timeStr) => (
      <span>{timeStr}</span>
    )
  }
</CountDown>
```

#### formatString

目前只支持年（Y）、月（M）、日（D）、时（H）、分（m）、秒（s）这几个换算单位。

###### 字符占用

默认情况下Y/M/D/h/m/s这几个字符将转换为对应的时间，而连续的字符，如ss将会转换为至少为2位的剩余秒数。那么如果要格式化为'60s'的时候怎么办？

可以尝试以下方案：

```javascript
<CountDown
  duration={60}
  formatString="ss秒"
>
  {
    (timeStr) => (
      <span>{timeStr.replace('秒', 's')}</span>
    )
  }
</CountDown>
```

#### 倒计时的两种场景

你可以选择其中一种方式来设置倒计时的终止时间：

+ duration：持续多久，单位秒。例如你希望倒计时持续计数60秒

+ endTime: 你可以传入一个结束时间文本(并传入解析该时间文本的解析字符串)，例如你希望在2021年11月11日的23点59分59秒结束倒计时

当都传递时，将以 endTime 为准

#### API

| 成员 | 说明 | 类型 | 默认值 | 版本 |
| --- | --- | --- | --- | --- |
| duration | 倒计时持续时长，单位s | number | 0 | 0.0.4 |
| endTime | 结束时间字符串 | string | - | 0.0.4 |
| parseFormatString | endTime的解析字符串，将会调用dayjs(endTime, parseFormatString) | string | 'YYYY-MM-DD HH:mm:ss' | 0.0.4 |
| formatString | 倒计时的格式化文本 | string | 'mm:ss' | 0.0.4 |
| onFinished | 倒计时归零时触发的回调 | () => void | - | 0.0.4 |
