"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _dict = require("../_config/dict");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

;
;
var replaceTag = '$$prefix$$';
var classMap = {
  show: "".concat(replaceTag, "-fade-op-1"),
  hide: "".concat(replaceTag, "-fade-op-0")
};
var FadeStatusMap = {
  showing: 'showing',
  hiding: 'hiding'
};

var Fade = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Fade, _React$Component);

  var _super = _createSuper(Fade);

  function Fade(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, Fade);
    _this = _super.call(this, props);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "timer", undefined);

    var isElementShow = _this.getIsElementShow(props.show || false);

    var transitionClass = isElementShow ? props.show ? classMap.show : classMap.hide : classMap.hide;
    _this.state = {
      isElementShow: isElementShow,
      transitionClass: transitionClass
    };
    _this.handleTransitionEnd = _this.handleTransitionEnd.bind((0, _assertThisInitialized2["default"])(_this));
    return _this;
  }

  (0, _createClass2["default"])(Fade, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this2 = this;

      if (prevProps.show !== this.props.show) {
        clearTimeout(this.timer);

        if (this.props.show) {
          this.status = FadeStatusMap.showing;
          this.setState({
            isElementShow: true,
            transitionClass: classMap.hide
          }, function () {
            _this2.timer = window.setTimeout(function () {
              _this2.setState({
                transitionClass: classMap.show
              });
            }, 50);
          });
        } else {
          this.status = FadeStatusMap.hiding;
          this.setState({
            transitionClass: classMap.hide
          });
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.timer);
    }
  }, {
    key: "getIsElementShow",
    value: function getIsElementShow(showStatus) {
      if (showStatus) {
        return true;
      } else {
        return !this.props.needDestroy;
      }
    }
  }, {
    key: "getTimingFunction",
    value: function getTimingFunction() {
      var _this$props = this.props,
          show = _this$props.show,
          timingFunction = _this$props.timingFunction,
          showTimingFunction = _this$props.showTimingFunction,
          hideTimingFunction = _this$props.hideTimingFunction;

      if (show) {
        return showTimingFunction || timingFunction || undefined;
      }

      return hideTimingFunction || timingFunction || undefined;
    }
  }, {
    key: "handleTransitionEnd",
    value: function handleTransitionEnd() {
      var _this$props2 = this.props,
          onShow = _this$props2.onShow,
          onHide = _this$props2.onHide,
          onChange = _this$props2.onChange,
          needDestroy = _this$props2.needDestroy;

      if (this.status) {
        var _isShow = false;

        if (this.status === FadeStatusMap.hiding) {
          this.setState({
            isElementShow: !needDestroy
          }, function () {
            typeof onHide === 'function' && onHide();
          });
        }

        if (this.status === FadeStatusMap.showing) {
          _isShow = true;
          typeof onShow === 'function' && onShow();
        }

        typeof onChange === 'function' && onChange(_isShow);
        this.status = undefined;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props3 = this.props,
          show = _this$props3.show,
          propsChildren = _this$props3.children,
          speed = _this$props3.speed,
          delay = _this$props3.delay,
          needDestroy = _this$props3.needDestroy,
          limitTstProperty = _this$props3.limitTstProperty,
          timingFunction = _this$props3.timingFunction,
          showTimingFunction = _this$props3.showTimingFunction,
          hideTimingFunction = _this$props3.hideTimingFunction,
          prefixCls = _this$props3.prefixCls,
          className = _this$props3.className,
          style = _this$props3.style,
          onShow = _this$props3.onShow,
          onHide = _this$props3.onHide,
          onChange = _this$props3.onChange,
          _onTransitionEnd = _this$props3.onTransitionEnd,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props3, ["show", "children", "speed", "delay", "needDestroy", "limitTstProperty", "timingFunction", "showTimingFunction", "hideTimingFunction", "prefixCls", "className", "style", "onShow", "onHide", "onChange", "onTransitionEnd"]);
      var _this$state = this.state,
          isElementShow = _this$state.isElementShow,
          transitionClass = _this$state.transitionClass;

      var children = _react["default"].Children.only(propsChildren);

      if (isElementShow && (0, _typeof2["default"])(children) === 'object') {
        return _objectSpread(_objectSpread({}, children), {}, {
          props: _objectSpread(_objectSpread(_objectSpread({}, children.props), restProps), {}, {
            style: _objectSpread(_objectSpread(_objectSpread({}, children.props.style || {}), {}, {
              transitionProperty: limitTstProperty ? 'opacity' : undefined
            }, style || {}), {}, {
              transitionDuration: "".concat(speed, "s"),
              transitionDelay: delay ? "".concat(delay, "s") : undefined,
              transitionTimingFunction: this.getTimingFunction()
            }),
            onTransitionEnd: function onTransitionEnd(e) {
              if (typeof _onTransitionEnd === 'function') {
                _onTransitionEnd(e);
              }

              var selfTransitionFunc = children.props.onTransitionEnd;

              if (typeof selfTransitionFunc === 'function') {
                selfTransitionFunc(e);
              }

              _this3.handleTransitionEnd();
            },
            className: (0, _classnames["default"])(className, children.props.className, "".concat(prefixCls, "-fade"), transitionClass.replace(replaceTag, prefixCls))
          })
        });
      }

      return null;
    }
  }]);
  return Fade;
}(_react["default"].Component);

(0, _defineProperty2["default"])(Fade, "defaultProps", {
  show: false,
  delay: 0,
  speed: 0.5,
  needDestroy: false,
  prefixCls: _dict.defaultPrefixCls,
  limitTstProperty: true,
  showTimingFunction: '',
  hideTimingFunction: '',
  timingFunction: 'ease'
});
var _default = Fade;
exports["default"] = _default;