"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _copyToClipboard = _interopRequireDefault(require("copy-to-clipboard"));

var _classnames = _interopRequireDefault(require("classnames"));

var _index = _interopRequireDefault(require("../_hook/useRefState/index"));

var _input = _interopRequireDefault(require("../input/input"));

var _dict = require("../_config/dict");

;
;

function GridPwd(props, ref) {
  var _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? _dict.defaultPrefixCls : _props$prefixCls,
      _props$gridCount = props.gridCount,
      gridCount = _props$gridCount === void 0 ? 6 : _props$gridCount,
      _props$type = props.type,
      type = _props$type === void 0 ? "tel" : _props$type,
      className = props.className,
      onFinished = props.onFinished,
      onChange = props.onChange,
      restProps = (0, _objectWithoutProperties2["default"])(props, ["prefixCls", "gridCount", "type", "className", "onFinished", "onChange"]);

  var _useRefState = (0, _index["default"])(false),
      _useRefState2 = (0, _slicedToArray2["default"])(_useRefState, 2),
      lockRef = _useRefState2[0],
      setIsLock = _useRefState2[1];

  var _useState = (0, _react.useState)(''),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      pwd = _useState2[0],
      setPwd = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      isFocus = _useState4[0],
      setIsFocus = _useState4[1];

  var inputRef = (0, _react.useRef)();

  var doFocusInput = function doFocusInput() {
    (0, _copyToClipboard["default"])('');
    inputRef.current.focus();
  };

  var doBlurInput = function doBlurInput() {
    inputRef.current.blur();
  };

  var reset = function reset() {
    setPwd('');
  };

  var resetAndFocus = function resetAndFocus() {
    reset();
    doFocusInput();
  };

  var onChangePwd = function onChangePwd(v) {
    if (lockRef.current) {
      return;
    }

    setPwd(v);
    typeof onChange === 'function' && onChange(v);

    if (v.length === gridCount) {
      if (typeof onFinished === 'function') {
        var lockCb = function lockCb() {
          setIsLock(false);
        };

        doBlurInput();
        setIsLock(true);
        onFinished(v, lockCb);
      }
    }
  };

  (0, _react.useImperativeHandle)(ref, function () {
    return {
      reset: reset,
      resetAndFocus: resetAndFocus
    };
  });

  var renderGridItem = function renderGridItem() {
    var grids = [];
    var pwdLen = pwd.length;

    for (var i = 0; i < gridCount; i++) {
      var _cn;

      grids.push( /*#__PURE__*/_react["default"].createElement("div", {
        key: i,
        className: (0, _classnames["default"])("".concat(prefixCls, "-grid-pwd-item"), (_cn = {}, (0, _defineProperty2["default"])(_cn, "".concat(prefixCls, "-grid-pwd-has-value"), i < pwdLen), (0, _defineProperty2["default"])(_cn, "".concat(prefixCls, "-grid-pwd-next-grid"), i === pwdLen), _cn))
      }));
    }

    return grids;
  };

  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    className: (0, _classnames["default"])("".concat(prefixCls, "-grid-pwd"), className, (0, _defineProperty2["default"])({}, "".concat(prefixCls, "-grid-pwd-focus"), isFocus))
  }, restProps, {
    onClick: doFocusInput
  }), renderGridItem(), /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-grid-pwd-input")
  }, /*#__PURE__*/_react["default"].createElement(_input["default"], {
    type: type,
    value: pwd,
    ref: inputRef,
    maxLength: gridCount,
    onChange: onChangePwd,
    disabled: lockRef.current,
    onFocus: function onFocus() {
      setIsFocus(true);
    },
    onBlur: function onBlur() {
      setIsFocus(false);
    },
    autoFocus: !lockRef.current,
    onPaste: function onPaste(e) {
      e.stopPropagation();
      e.preventDefault();
      return false;
    }
  })));
}

;

var _default = /*#__PURE__*/(0, _react.forwardRef)(GridPwd);

exports["default"] = _default;