"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Close90Outlined = _interopRequireDefault(require("../_icon/Close90Outlined"));

var _fadeIn = _interopRequireDefault(require("../fade/fadeIn"));

var _dict = require("../_config/dict");

;
;

function Modal(props) {
  var className = props.className,
      width = props.width,
      _props$visible = props.visible,
      visible = _props$visible === void 0 ? true : _props$visible,
      _props$mask = props.mask,
      mask = _props$mask === void 0 ? true : _props$mask,
      _props$maskClosable = props.maskClosable,
      maskClosable = _props$maskClosable === void 0 ? false : _props$maskClosable,
      _props$confirmCareful = props.confirmCareful,
      confirmCareful = _props$confirmCareful === void 0 ? false : _props$confirmCareful,
      _props$closeCorner = props.closeCorner,
      closeCorner = _props$closeCorner === void 0 ? false : _props$closeCorner,
      _props$confirmable = props.confirmable,
      confirmable = _props$confirmable === void 0 ? true : _props$confirmable,
      _props$hideDestroy = props.hideDestroy,
      hideDestroy = _props$hideDestroy === void 0 ? true : _props$hideDestroy,
      _props$okText = props.okText,
      okText = _props$okText === void 0 ? '确定' : _props$okText,
      _props$cancelText = props.cancelText,
      cancelText = _props$cancelText === void 0 ? '取消' : _props$cancelText,
      title = props.title,
      footer = props.footer,
      customStructure = props.customStructure,
      children = props.children,
      _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? _dict.defaultPrefixCls : _props$prefixCls,
      onOk = props.onOk,
      onCancel = props.onCancel,
      onShow = props.onShow,
      onHide = props.onHide,
      restProps = (0, _objectWithoutProperties2["default"])(props, ["className", "width", "visible", "mask", "maskClosable", "confirmCareful", "closeCorner", "confirmable", "hideDestroy", "okText", "cancelText", "title", "footer", "customStructure", "children", "prefixCls", "onOk", "onCancel", "onShow", "onHide"]);

  var onClickMask = function onClickMask(e) {
    if (maskClosable) {
      typeof onCancel === 'function' && onCancel(e);
    }
  };

  var renderFooter = function renderFooter() {
    if (footer === null) {
      return null;
    }

    var okBtn = /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(prefixCls, "-modal-button ").concat(prefixCls, "-modal-ok"),
      onClick: onOk
    }, okText);

    var cancelBtn = /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(prefixCls, "-modal-button ").concat(prefixCls, "-modal-cancel"),
      onClick: onCancel
    }, cancelText);

    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(prefixCls, "-modal-footer")
    }, footer || (confirmCareful ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, Boolean(confirmable) && okBtn, cancelBtn) : /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, cancelBtn, Boolean(confirmable) && okBtn)));
  };

  var renderedCloseCorner = function renderedCloseCorner() {
    if (closeCorner) {
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-modal-corner-close"),
        onClick: onCancel
      }, typeof closeCorner === 'boolean' ? /*#__PURE__*/_react["default"].createElement(_Close90Outlined["default"], null) : closeCorner);
    }

    return null;
  };

  return /*#__PURE__*/_react["default"].createElement(_fadeIn["default"], {
    show: visible,
    needDestroy: hideDestroy,
    limitTstProperty: true,
    onShow: onShow,
    onHide: onHide
  }, /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    className: (0, _classnames["default"])("".concat(prefixCls, "-modal"), className)
  }, restProps), !!mask && /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-modal-mask"),
    onClick: onClickMask
  }), customStructure ? /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-modal-custom-content")
  }, typeof children === 'function' ? children(onOk, onCancel) : children, renderedCloseCorner()) : /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(prefixCls, "-modal-content"), (0, _defineProperty2["default"])({}, "".concat(prefixCls, "-modal-content-no-title"), !title)),
    style: width ? {
      width: width
    } : undefined
  }, !!title && /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-modal-header")
  }, title), /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-modal-body")
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-modal-body-box")
  }, typeof children === 'function' ? children(onOk, onCancel) : children)), renderFooter(), renderedCloseCorner())));
}

var _default = Modal;
exports["default"] = _default;