"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _useRefState3 = _interopRequireDefault(require("../_hook/useRefState"));

var _index = _interopRequireDefault(require("../drawer/index"));

var _index2 = _interopRequireDefault(require("../picker-view/index"));

var _dict = require("../_config/dict");

require("../drawer/style/css");

require("../picker-view/style/css");

;

var _default = function _default(props) {
  var _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? _dict.defaultPrefixCls : _props$prefixCls,
      _props$cancelText = props.cancelText,
      cancelText = _props$cancelText === void 0 ? '取消' : _props$cancelText,
      _props$okText = props.okText,
      okText = _props$okText === void 0 ? '确定' : _props$okText,
      title = props.title,
      _props$defaultValue = props.defaultValue,
      defaultValue = _props$defaultValue === void 0 ? [] : _props$defaultValue,
      onOk = props.onOk,
      onCreatePop = props.onCreatePop,
      popClassName = props.popClassName,
      onCancelCb = props.onCancel,
      maskClosable = props.maskClosable,
      children = props.children,
      restProps = (0, _objectWithoutProperties2["default"])(props, ["prefixCls", "cancelText", "okText", "title", "defaultValue", "onOk", "onCreatePop", "popClassName", "onCancel", "maskClosable", "children"]); // PickerView提交的实际值

  var _useState = (0, _react.useState)(defaultValue),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1]; // PickerView的实时值


  var _useRefState = (0, _useRefState3["default"])(defaultValue),
      _useRefState2 = (0, _slicedToArray2["default"])(_useRefState, 2),
      currentValueRef = _useRefState2[0],
      setCurrentValue = _useRefState2[1];

  var createPop = function createPop() {
    typeof onCreatePop === 'function' && onCreatePop();

    _index["default"].createDrawer({
      maskClosable: maskClosable,
      className: (0, _classnames["default"])("".concat(prefixCls, "-picker-wrapper"), popClassName),
      content: function content(onCancel) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-picker")
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-picker-control")
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-picker-cancel"),
          onClick: function onClick() {
            onCancel();
          }
        }, cancelText), /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-picker-title")
        }, title), /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-picker-ok"),
          onClick: function onClick() {
            onCancel(true);
          }
        }, okText)), /*#__PURE__*/_react["default"].createElement(_index2["default"], (0, _extends2["default"])({}, restProps, {
          defaultValue: currentValueRef.current,
          onChange: function onChange(v) {
            setCurrentValue(v);
          }
        })));
      },
      onCancel: function onCancel(close, isConfirm) {
        if (isConfirm) {
          var v = (0, _toConsumableArray2["default"])(currentValueRef.current);
          setValue(v);
          typeof onOk === 'function' && onOk(v);
        } else {
          var _v = (0, _toConsumableArray2["default"])(value);

          setCurrentValue(_v);
          typeof onCancelCb === 'function' && onCancelCb(_v);
        }

        close();
      }
    });
  };

  if (typeof children === 'function') {
    return children(createPop, value, currentValueRef.current);
  } else if (children) {
    // 当接受到数组类型的子节点或者纯文本的节点时, 用一层div包裹, 并在包裹的div上
    if (typeof children === 'string' || Array.isArray(children)) {
      return /*#__PURE__*/_react["default"].createElement("div", {
        onClick: function onClick() {
          createPop();
        },
        className: "".concat(prefixCls, "-picker-trigger")
      }, children);
    }

    return /*#__PURE__*/_react["default"].cloneElement(children, {
      onClick: function onClick(e) {
        createPop();
        var originOnClick = children.props.onClick;
        typeof originOnClick === 'function' && originOnClick(e);
      }
    });
  }

  return null;
};

exports["default"] = _default;