"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _reactDom = _interopRequireDefault(require("react-dom"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

;

function renderComponentNode(renderFn) {
  var prevProps = {};

  var render = function render() {
    console.error('renderFn is not a function');
  };

  var destroy = function destroy() {
    console.error('destroyFn is not a function');
  };

  var update = function update() {};

  if (typeof renderFn === 'function') {
    var div = document.createElement('div');
    document.body.appendChild(div);

    destroy = function destroy() {
      var unmountResult = _reactDom["default"].unmountComponentAtNode(div);

      if (unmountResult && div.parentNode) {
        div.parentNode.removeChild(div);
      }
    };

    render = function render(props) {
      var jsx = renderFn(_objectSpread(_objectSpread({}, prevProps), props || {}), update, destroy);
      prevProps = props || {};

      _reactDom["default"].render(jsx, div);
    };
  }

  update = function update(newProps) {
    render(newProps);
  };

  return {
    render: render,
    destroy: destroy,
    update: update
  };
}

var _default = renderComponentNode;
exports["default"] = _default;