"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _LoadingOutlined = _interopRequireDefault(require("@ant-design/icons/LoadingOutlined"));

var _index = _interopRequireDefault(require("../_icon/CloseCircle/index"));

var _index2 = _interopRequireDefault(require("../_icon/CheckCircle/index"));

var _index3 = _interopRequireDefault(require("../portal-factory/index"));

var _toast = _interopRequireDefault(require("../toast/toast"));

var _dict = require("../_config/dict");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var currentToast = null;
var timer = null;

var renderFn = function renderFn(props, _, destroy) {
  var originOnHide = props.onHide,
      restProps = (0, _objectWithoutProperties2["default"])(props, ["onHide"]);

  var onHideCb = function onHideCb() {
    typeof originOnHide === 'function' && originOnHide();
    destroy();
  };

  return /*#__PURE__*/_react["default"].createElement(_toast["default"], (0, _extends2["default"])({}, restProps, {
    onHide: onHideCb
  }));
};

var destroyCurrentToast = function destroyCurrentToast() {
  if (timer) {
    clearTimeout(timer);
    timer = null;
  }

  if (currentToast) {
    currentToast.destroy();
  }
};

var drawToast = function drawToast(config) {
  destroyCurrentToast();
  var pf = (0, _index3["default"])(renderFn);
  currentToast = pf;
  pf.render(config);
};

var Toast = function Toast(props) {
  return /*#__PURE__*/_reactDom["default"].createPortal( /*#__PURE__*/_react["default"].createElement(_toast["default"], props), document.body);
};

Toast.info = function (configOrContent) {
  var props = (0, _typeof2["default"])(configOrContent) === 'object' ? _objectSpread({}, configOrContent) : {};

  if (typeof configOrContent === 'string') {
    props.content = configOrContent;
  }

  drawToast(props);
};

Toast.loading = function (config) {
  var prefixCls = (config === null || config === void 0 ? void 0 : config.prefixCls) || _dict.defaultPrefixCls;

  var props = _objectSpread({
    icon: /*#__PURE__*/_react["default"].createElement(_LoadingOutlined["default"], {
      className: "".concat(prefixCls, "-toast-icon")
    }),
    duration: 0,
    content: '加载中...'
  }, config || {});

  drawToast(props);
};

Toast.delayLoading = function (delay, config) {
  var delayTime = delay || 500;
  timer = window.setTimeout(function () {
    Toast.loading(config);
    timer = null;
  }, delayTime);
};

Toast.fail = function (configOrContent) {
  var prefixCls = (0, _typeof2["default"])(configOrContent) === 'object' ? (configOrContent === null || configOrContent === void 0 ? void 0 : configOrContent.prefixCls) || _dict.defaultPrefixCls : _dict.defaultPrefixCls;
  var props = {
    icon: /*#__PURE__*/_react["default"].createElement(_index["default"], {
      className: "".concat(prefixCls, "-toast-icon")
    })
  };

  if ((0, _typeof2["default"])(configOrContent) === 'object') {
    props = _objectSpread(_objectSpread({}, props), configOrContent);
  }

  if (typeof configOrContent === 'string') {
    props.content = configOrContent;
  }

  drawToast(props);
};

Toast.success = function (configOrContent) {
  var prefixCls = (0, _typeof2["default"])(configOrContent) === 'object' ? (configOrContent === null || configOrContent === void 0 ? void 0 : configOrContent.prefixCls) || _dict.defaultPrefixCls : _dict.defaultPrefixCls;
  var props = {
    icon: /*#__PURE__*/_react["default"].createElement(_index2["default"], {
      className: "".concat(prefixCls, "-toast-icon")
    })
  };

  if ((0, _typeof2["default"])(configOrContent) === 'object') {
    props = _objectSpread(_objectSpread({}, props), configOrContent);
  }

  if (typeof configOrContent === 'string') {
    props.content = configOrContent;
  }

  drawToast(props);
};

Toast.hide = function () {
  destroyCurrentToast();
};

var _default = Toast;
exports["default"] = _default;