import React from 'react';
export interface DraggableElementProps {
    prefixCls?: string;
    className?: string;
    style?: React.CSSProperties;
    children?: React.ReactNode;
    position?: 'absolute' | 'fixed';
    initTop?: string;
    initLeft?: string;
    initRight?: string;
    initBottom?: string;
    isInView?: boolean;
    onClick?: () => void;
    [key: string]: any;
}
export interface DraggableElementState {
    top: string | undefined;
    left: string | undefined;
    right: string | undefined;
    bottom: string | undefined;
}
export declare function getPosition(beginPos?: string, endPos?: string): string;
export default class DraggableElement extends React.Component<DraggableElementProps, DraggableElementState> {
    shouldTriggerOnClick: Boolean;
    ref: React.RefObject<HTMLDivElement> | undefined;
    containerRef: React.RefObject<HTMLDivElement> | undefined;
    initPageX: number | undefined;
    initPageY: number | undefined;
    transformX: number | undefined;
    transformY: number | undefined;
    constructor(props: DraggableElementProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    resetInnerState: () => void;
    handleTouchStart: (evt: TouchEvent) => void;
    handleTouchMove: (evt: TouchEvent) => void;
    handleTouchEnd: (evt: TouchEvent) => void;
    handleTouchCancel: (evt: TouchEvent) => void;
    handleAdjustElement: () => void;
    render(): JSX.Element;
}
