import React from 'react';
export interface ModalCommonProps {
    className?: string;
    visible?: boolean;
    width?: string;
    mask?: boolean;
    maskClosable?: boolean;
    confirmable?: boolean;
    customStructure?: boolean;
    confirmCareful?: boolean;
    title?: React.ReactNode;
    cancelText?: React.ReactNode;
    closeCorner?: boolean | React.ReactElement;
    footer?: React.ReactNode;
    okText?: React.ReactNode;
    hideDestroy?: boolean;
    onShow?: () => void;
    onHide?: () => void;
}
export interface ModalProps extends ModalCommonProps {
    onCancel?: (e: React.MouseEvent) => void;
    onOk?: () => void;
    children?: React.ReactNode;
    [key: string]: any;
}
export interface QuickModalProps extends ModalCommonProps {
    onCancel?: (close: () => void) => void;
    onOk?: (close: () => void) => void;
    content?: React.ReactNode;
    [key: string]: any;
}
declare function Modal(props: ModalProps): JSX.Element;
export default Modal;
